-- 2006-08-20
-- Sektor (www.gtamp.com/PSP) threw this together
-- List taken from www.lilligren.com/Redneck/300_reasons_redneck.htm
-- Wordwrap function converted to LUA from this script www.asp101.com/samples/wordwrap.asp

intFactPosX = 10
intFactPosY = 100
intCounterPosX = 10
intCounterPosY = 260
intMaxLineLength = 30
splash = Image.load("splash.png")
pic1 = Image.load("pic1.jpg")
pic2 = Image.load("pic2.jpg")

function displayfact()
  Image:blit(0,0,pic1)	  	  
  Image:blit(260,0,pic2)	  	  
  wordwrappedfacts = wordwrap(fact[i],intMaxLineLength)
 
  for j=1,table.getn(splitfact) do
    screen:print (intFactPosX, intFactPosY + j * 11, splitfact[j], red)
  end
	  
  screen:print(intCounterPosX,intCounterPosY,"GTAMP.com/PSP - " .. i .. "/" .. table.getn(fact),yellow)
  screen.flip()
  screen.waitVblankStart(5)
end

function wordwrap(strTextToBeWrapped, intMaxLineLength)
  strWrappedText = ""        --Result storage
  --intLengthOfInput         --Length of original
  --intCurrentPosition       --Where we're at now
  --intCurrentLineStart      --Where the current line starts
  intPositionOfLastSpace = 0 --Last space we saw
  lines = 0
  splitfact = {}
	
  --Get this once so we don't have to keep checking
  intLengthOfInput = string.len(strTextToBeWrapped)
	 
  --Start both of these at the beginning
  intCurrentPosition = 1
  intCurrentLineStart = 1
	
  --Loop through until we get to the end
  while intCurrentPosition < intLengthOfInput do
     --if the current position is a space, make a note of
     --its location for later use.
     if string.sub(strTextToBeWrapped, intCurrentPosition, intCurrentPosition) == " " then
        intPositionOfLastSpace = intCurrentPosition
     end
	 
	 --if we're at what should be the end of a line, we go back
	 --to the last space we saw and cut the line there.
	 if intCurrentPosition == intCurrentLineStart + intMaxLineLength then
	   --Append this latest line to our result
	   lines=lines+1
	   splitfact[lines] = string.sub(strTextToBeWrapped, intCurrentLineStart,
	   intCurrentLineStart-1+intPositionOfLastSpace - intCurrentLineStart + 1)
			   
	   strWrappedText = strWrappedText ..  splitfact[lines] .. "\n"
	   
	   --Reset the next line's starting point to the point we
	   --used for the last one's end + 1.
	   intCurrentLineStart = intPositionOfLastSpace + 1
	   
	   --Remove any leading spaces that might mess up our
	   --character count.  if you want to just pull off one,
	   --switch this to a simple if conditional instead of
	   --looping.
	   while string.sub(strTextToBeWrapped, intCurrentLineStart, intCurrentLineStart) == " " do
	    	intCurrentLineStart = intCurrentLineStart + 1
	   end
	 end
	 
	 --Increment our location indicator.
	 intCurrentPosition = intCurrentPosition + 1
	end
	
	--Since the loop ends before we add the remaining text,
	--add remaining text as the last line.
	strWrappedText = strWrappedText .. string.sub(strTextToBeWrapped, intCurrentLineStart) .. "\n"
	
	lines=lines+1
	splitfact[lines] = string.sub(strTextToBeWrapped, intCurrentLineStart)
	--Return our result to the calling line.
	return strWrappedText
end

--display splash screen
Image:blit(0,0,splash)
screen.flip()
screen.waitVblankStart()

while true do
   pad = Controls.read()
   if pad:circle() or pad:cross() then
     break
   end
end

black = Color.new(0,0,0)
white = Color.new(255, 255, 255)
yellow = Color.new(222, 255, 0)
red = Color.new(255, 0, 0)
fact = {}
i=0

for line in io.lines ("list.txt") do
  if string.len(line) ~= 1 then
    i=i+1
    fact[i] = string.sub(line, 1, string.len(line)-1) 
  end
end 

-- Initialize the pseudo random number generator
math.randomseed( os.time() )
math.random(); math.random(); math.random()

i = math.random(1,table.getn(fact))
displayfact()

while true do
   pad = Controls.read()
   -- if pad:select() then screen:save("screenshot.tga") end
   if pad:circle() or pad:cross() or pad:left() or pad:right() then
      screen:clear()
	  if pad:circle() or pad:cross() then
	    i = math.random(1,table.getn(fact))
	  elseif pad:right() then
          i = i + 1
	    if i>table.getn(fact) then i=1 end
	      elseif pad:left() then
	        i = i - 1
	        if i==0 then i=table.getn(fact) end
	    end	
	displayfact()
   end

   if pad:start() then
      break
   end
   screen.waitVblankStart()
end